#ifndef __NAV_H__
#define __NAV_H__

#include <sys/types.h>
#include "DVDPlayerAPI.h"
#include "plugin/nav.h"
#include "plugin/plugin.h"

// open input device/file and associated plugins (former SetRoot)
int navOpenInput (char *);

// close current input device/file and associated plugins
int navCloseInput (void);

// open output device (former SetDevice)
int navOpenOutput (char *plugin_path, char *output_path);

// close current output device
int navCloseOutput (void);

#define STATUS_STOP		0
#define STATUS_PAUSE		1
#define STATUS_PAUSE_ON		1
#define STATUS_PAUSE_OFF	2
#define STATUS_PLAY		3
#define STATUS_FINISH		4

// set status of navigator (see STATUS_* above)
int navSetStatus (u_int status);

// get internal information of navigator status 
int navGetStatus (void);

// get navigation tree (for DVD == PTT and for DVB == SI)
nav_tree_t *navGetInfo (void);

#define CB_CHANGE	1
#define CB_PRINT	2
	
// register callbacks
int navRegisterCb (u_int id, void (*cb) (void *, int ), void *data);

// unregister callback
int navUnregisterCb (u_int id);

#endif
